/* 90 algorithm van euclides (greatest common dividor)       */
/* author: Jan Feenstra                                      */

/* file gcd.c                                                */
/* version: 1.0                                              */

#include <stdio.h>

int gcd(int a, int b) {
  while ((a!=0) && (b!=0)) {
    if (a > b) {
      a = a % b;
    } else {
      b = b % a;
    }
  }

  if (a>b)  
       return a;
  else
       return b;
}


int computeGCD(int a, int b) {

  int d;


  if (a < 0) {
      if (b < 0) {
        if (a!=b) {
          d = gcd( -a, -b);
        } else
        {
          d = 1;
        }
      } else {
        if (a!=b) {
          d = gcd( -a, b);
        } else
        {
          d = 1;
        }
      }
  } else {
      if (b < 0) {
        if (a!=b) {
          d = gcd( a, -b);
        } else
        {
          d = 1;
        }
      } else {
        if (a!=b) {
          d = gcd( a, b);
        } else
        {
          d = 1;
        }
      }
  }  

  return d;

}

#ifndef TEST
int main(int argc, char *argv[]) {

  int d,a,b;
  if (argc!=3) {
    fprintf(stdout,"syntax: gcd <nr1> <nr2>\n");
    return(-1);
  }

  sscanf(argv[1], "%d", &a);
  sscanf(argv[2], "%d", &b);
  d=computeGCD(a,b);
  fprintf(stdout,"gcd(%d, %d) = %d\n",  a, b, d);
	return 1;
}
#endif