
#include "..\IRSSrc\irs.h"
#include "testIRS.h"



/*-------------------------------------------------------------------------*
 * Helper functions
 *-------------------------------------------------------------------------*/
int IRSTestSetUp(void){return 0;}
int IRSTestTearDown(void){return 0;}
/*-------------------------------------------------------------------------*
 * TestIRS Test Cases
 *-------------------------------------------------------------------------*/

void IRSValid(void)
{
#define noPaymentsValid 5

  double actualContrib;
  double payments[noPaymentsValid]= {1000.0, 1234.9, 0.1, 42, 50000};
  const double expectedContrib =-50777.0;
  actualContrib = iraContribution(100000.0,'S',payments,noPaymentsValid );
  
  CU_ASSERT_DOUBLE_EQUAL(expectedContrib,actualContrib, 0.0);
  //last argument indicates required precision for equal test of float points

  // specify more "valid" test here
}

// specify more test cases here


// Registers the fixture into the 'registry'

CU_pSuite getIRSSuite(){
	CU_pSuite pSuite = NULL;
   /* add a suite to the registry */
   pSuite = CU_add_suite("Suite_1", IRSTestSetUp, IRSTestTearDown);
   if (NULL == pSuite) {
      CU_cleanup_registry();
      return NULL;
   }
 
   /* add the tests to the suite */
   if ((NULL == CU_add_test(pSuite, "sample irs test case", IRSValid)))
   {
      CU_cleanup_registry();
      return NULL;
   }

   /* ADD MORE TEST CASES HERE */


   return pSuite;
}

