// IRS.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <fstream>
using namespace std;

#include <cppunit/CompilerOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>
#include <cppunit/XmlOutputter.h>


int RunAllTests(void)
{
	bool wasSucessful;

  // Get the top level suite from the registry
  CPPUNIT_NS::Test *suite = CPPUNIT_NS::TestFactoryRegistry::getRegistry().makeTest();

  // Adds the test to the list of test to run
  CPPUNIT_NS::TextUi::TestRunner runner;
  runner.addTest( suite );

  // Change the default outputter to a compiler error format outputter
  //runner.setOutputter( new CPPUNIT_NS::CompilerOutputter( &runner.result(),
  //                                                     std::cerr ) );
  ofstream reportFile("GCDTestReport.xml");

  CPPUNIT_NS::XmlOutputter * xout=new CPPUNIT_NS::XmlOutputter( &runner.result(),
                                   reportFile );
	xout->setStyleSheet("report.xsl");
 
    runner.setOutputter( xout);
  // Run the test.
  wasSucessful = runner.run();

  reportFile.close();
  // Return error code 1 if the one of test failed.
  return wasSucessful ? 0 : 1;
}


int main(int argc, char* argv[])
{

	return RunAllTests();;
}

