#include <stdio.h>

#include "CuTest.h"

//CuSuite* CuGetSuite();
#ifdef STUB_classifyTriangle
CuSuite* TestStubCheckTriangletGetSuite();
#else
CuSuite* TestTriangleGetSuite();
CuSuite* TestStringToIntGetSuite();
CuSuite* TestCheckTriangletGetSuite();
#endif


void RunAllTests(void)
{
	CuString *output = CuStringNew();
	CuSuite* suite = CuSuiteNew();
#ifdef STUB_classifyTriangle
	CuSuiteAddSuite(suite, TestStubCheckTriangletGetSuite());
#else
	CuSuiteAddSuite(suite, TestTriangleGetSuite());
	CuSuiteAddSuite(suite, TestStringToIntGetSuite());
	CuSuiteAddSuite(suite, TestCheckTriangletGetSuite());
#endif
	CuSuiteRun(suite);
	CuSuiteSummary(suite, output);
	CuSuiteDetails(suite, output);
	printf("%s\n", output->buffer);
}

int main(void)
{
	RunAllTests();
}
