#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include"triangle.h"

//if BUG is defined the program will fail the following tests
// a.out 12 13 5 ==> should print rectangular
// a.out +1 13 5 ==> first argument is valid!



static char * TriangleText[6]={
  "Invalid Triangle",
  "Rectangular Triangle",
  "Equilateral Triangle",
  "Isosceles Triangle",
  "Scalene Triangle",
  "Unknown Triangle"
};

#ifndef STUB_classifyTriangle
TriangleKind  classifyTriangle(int a, int b, int c) {

  TriangleKind kind=invalidTriangle;
  
  if((a>0) && (b>0) && (c>0)) {
    
    if(! (a+b >= c) ||
	(b+c >= a) ||
	(a+c >= b) ) {
#ifndef BUG
      //kind=unknownTriangle;
      if ((a*a == b*b + c*c) ||
	  (b*b == a*a + c*c) || 
	  (c*c == b*b + a*a))
	kind=rectangularTriangle;
      else
#endif
	if (a == b && b == c)
	kind=equilateralTriangle;
      else if ((a == b) ||      
	       (a == c) ||
	       (b == c))   
	kind= isoscelesTriangle;
      else if ((a !=b && b!=c))
	kind=scaleneTriangle;
    }
  }
  return kind;
}
#endif 
boolean_t stringToInt(char* s, int *a) {
  int err;
  int i=0;

#ifdef BUG
  if((s[0]=='-')||(s[0]=='-')){
    i++;
  }

    if( (strlen(&s[i])>10) ||
	(strlen(&s[i])<1) )
    return B_FALSE;

    for(;i<=strlen(s)-1;i++) 
    if(!isdigit(s[i])) 
      return B_FALSE;
#else
  if((s[0]=='+')||(s[0]=='-')){
    i++;
  }	
  if( (strlen(&s[i])>10) ||
      (strlen(&s[i])<1) )
    return B_FALSE;

  for(;i<=strlen(s)-1;i++) 
    if(!isdigit(s[i])) 
      return B_FALSE;
#endif 

  errno=0;
  *a=atoi(s);
  //  printf("%d\n",*a);

  if(errno!=0) 
    return B_FALSE;
  return B_TRUE;
}

char* checkTriangle(int argc, char ** argv) {
  char * result="";
  int errCount=0;
  int a,b,c;
  
  if(argc==4) {
    
    if(!stringToInt(argv[1],&a)) {
      return "Error in first argument";
      errCount++;
    }
    if(!stringToInt(argv[2],&b)) {
      return "Error in second argument\n";
      errCount++;
    }
    if(!stringToInt(argv[3],&c)) {
      return "Error in third argument\n";
      errCount++;
    }
    if(errCount==0)
      return TriangleText[classifyTriangle(a,b,c)];
    
  }
  else{
    errCount++;

    return "Incorrect Number of Arguments\n";
  }
  return result;
}

#ifndef TEST
int main(int argc, char ** argv) {
  printf("%s\n", checkTriangle(argc, argv));
  return 0;
}
#endif
