

#include "testTriangle.h"



/*-------------------------------------------------------------------------*
 * Helper functions
 *-------------------------------------------------------------------------*/
int TriangleTestSetUp(void){return 1;}
int TriangleTestTearDown(void){return 1;}
/*-------------------------------------------------------------------------*
 * TestIRS Test Cases
 *-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*
 * classifyTriangle Test
 *-------------------------------------------------------------------------*/

void validClassification(){
  CU_ASSERT_EQUAL(rectangularTriangle, classifyTriangle(13,12,5) );

  //for demo purposes demonstrate a testcase that fails (wrong expected output)
  CU_ASSERT_EQUAL(rectangularTriangle, classifyTriangle(13,12,6) );

  CU_ASSERT_EQUAL(scaleneTriangle, classifyTriangle(15,10,5) );

  CU_ASSERT_EQUAL(equilateralTriangle, classifyTriangle(INT_MAX,INT_MAX,INT_MAX) );

  CU_ASSERT_EQUAL(isoscelesTriangle, classifyTriangle(1,1,2) );
}

void  invalidClassification(){
  CU_ASSERT_EQUAL(invalidTriangle, classifyTriangle(100,0,10) );

  CU_ASSERT_EQUAL(invalidTriangle, classifyTriangle(100,50,-1) );
}



void  strToInt(){

  int actual_val;

  CU_ASSERT(stringToInt("1",&actual_val));
  CU_ASSERT_EQUAL(1,actual_val);

  CU_ASSERT(stringToInt("+0",&actual_val));
  CU_ASSERT_EQUAL(0, actual_val );


  CU_ASSERT(stringToInt("999",&actual_val));  
  CU_ASSERT_EQUAL(999, actual_val );

  CU_ASSERT(stringToInt("999999999",&actual_val));
  CU_ASSERT_EQUAL(999999999, actual_val );

  CU_ASSERT(stringToInt("-0",&actual_val));
  CU_ASSERT_EQUAL(0, actual_val );

  CU_ASSERT(stringToInt("-1",&actual_val));
  CU_ASSERT_EQUAL( -1, actual_val );

  CU_ASSERT(stringToInt("-999",&actual_val));
  CU_ASSERT_EQUAL(-999, actual_val );

  CU_ASSERT(stringToInt("-999999999",&actual_val));
  CU_ASSERT_EQUAL(-999999999, actual_val );

  CU_ASSERT(!stringToInt("-9999999999999",&actual_val));

  CU_ASSERT(!stringToInt("-",&actual_val));

  CU_ASSERT(!stringToInt("",&actual_val));
 
  CU_ASSERT(!stringToInt("kurt",&actual_val));
  
}


/*-------------------------------------------------------------------------*
 * checkTriangle Test
 *-------------------------------------------------------------------------*/
//argc assumed to correctly indicate number of arguments in argv vector
//since this is normally done by the OS and C startup code (assumed correct).
/*
  "Invalid Triangle",
  "Rectangular Triangle",
  "Equilateral Triangle",
  "Isosceles Triangle",
  "Scalene Triangle",
*/
static char * programName="testTriangle";

void  testCheckTriangle(){
  char*argv1[4]={programName,"13","12","5"};
  char* argv2[4]=  {programName,"15","10","5"};
  char* argv3[4]=  {programName,"999999999","999999999","999999999"};
  char* argv4[4]=  {programName,"1","1","2"};
  char* argv5[4]=  {programName,"100","100","0"};
  char* argv6[4]=  {programName,"100","100","-1"};
  char* argv7[4]=  {programName,"100","100","peter"};
  char*argv8[3]=  {programName,"100","peter"};
  char*argv9[5]=  {programName,"100","peter","100",""};

  CU_ASSERT_STRING_EQUAL( "Rectangular Triangle", checkTriangle(4,argv1));
  CU_ASSERT_STRING_EQUAL( "Scalene Triangle",  checkTriangle(4,argv2 )); 
  CU_ASSERT_STRING_EQUAL( "Equilateral Triangle", checkTriangle(4,argv3));
  CU_ASSERT_STRING_EQUAL( "Isosceles Triangle", checkTriangle(4,argv4));
  CU_ASSERT_STRING_EQUAL( "Invalid Triangle", checkTriangle(4,argv5));
  CU_ASSERT_STRING_EQUAL( "Invalid Triangle", checkTriangle(4,argv6));
  CU_ASSERT_STRING_EQUAL( "Error in third argument\n", checkTriangle(4,argv7));
  CU_ASSERT_STRING_EQUAL( "Incorrect Number of Arguments\n", checkTriangle(2,argv8));
  CU_ASSERT_STRING_EQUAL( "Incorrect Number of Arguments\n", checkTriangle(5,argv9));
}

// Registers the fixture into the 'registry'

CU_pSuite getTriangleSuite(){
	CU_pSuite pSuite = NULL;
   /* add a suite to the registry */
  // pSuite = CU_add_suite("Suite_1", TriangleTestSetUp, TriangleTestTearDown);
      pSuite = CU_add_suite("Suite_1", NULL,NULL);
   if (NULL == pSuite) {
      CU_cleanup_registry();
      return NULL;
   }

   /* add the tests to the suite */
   if ((NULL == CU_add_test(pSuite, "Tests classification of valid triangles", validClassification)) ||
	   (NULL == CU_add_test(pSuite, "Tests classification of invalid triangles", invalidClassification)) ||
       (NULL == CU_add_test(pSuite, "Tests for string conversion", invalidClassification)) ||
       (NULL == CU_add_test(pSuite, "Tests triangle main driver", testCheckTriangle))
	   )
   {
	   printf("%s\n", CU_get_error_msg());
      CU_cleanup_registry();
      return NULL;
   }


   return pSuite;
}
